function C=docholesky (PAP, PiProj, Ni, Q)
global text
% % here is Cholesky 
text='Cholesky Basis Function';
% we cheat a bit on the rank
L=chol(PAP+eps*eye(Ni),'lower');
% and fix the cheat in the lower corner
L(Ni-Q+1:end,Ni-Q+1:end)=eye(Q);
% to be able to invert:
Li=inv(L');
% Now we check if the cheat was OK 
G=Li'*PAP*Li;
% the following must be zero if G is near to diagonal
tng=norm(G-diag(diag(G)))
% if this was small, the cheat was OK.
C=PiProj*Li;
% end of Cholesky
